#include "fonction.hpp"
#include <fstream>


const double X_max = 5;
const int n_pas = 200;
const double dx = X_max / n_pas;


int main(void)
{
  std::ofstream sortie("cosinus.dat");
  
  trigo F(1,1,0);
  for (int i=-n_pas; i<n_pas; i++)
	sortie << i*dx << " " << F(i*dx) << " " << F.delta(i*dx) << "\n";
  sortie.close();
  

  
  std::vector<double> coeffs(4);
  coeffs[3] = 1;
  coeffs[1] = -1;
  polynome P(coeffs);
  sortie.open("polynome.dat");
  for (int i=-n_pas; i<n_pas; i++)
	sortie << i*dx << " " << P(i*dx) << " " << P.delta(i*dx) << "\n";
  sortie.close();
  

  
}
