#include <iostream>


int main(void)
{
  int n=0, m=1;
  int *p = &n;
  // On definit deux variables entieres, et on fait pointer un pointeur vers la premiere
  

  std::cout << "n m p" << "\n";
  std::cout << n << " " << m << " " << *p << "\n";
  *p = 4;
  // On modifie la valeur a l'adresse p (c'est a dire la valeur de n)
  std::cout << n << " " << m << " " << *p << "\n";
  p = &m;
  // p pointe maintenant vers m
  std::cout << n << " " << m << " " << *p << "\n";


  
  std::cout << "\n" << "\n";


  
  int &r = n;
  // On fait maintenant pointer une reference vers n
  // La reference r pointera *toujours* vers n. (r est *constant*) 
  
  std::cout << "n m r" << "\n";
  std::cout << n << " " << m << " " << r << "\n";
  r = 5;
  // Modifie la valeur pointee par r
  std::cout << n << " " << m << " " << r << "\n";
  r = m;
  // Cette instruction remplace le contenu de r et n par celui de m. Elle ne change *pas* la variable pointee par r. 
  std::cout << n << " " << m << " " << r << "\n";
  n = 3;
  // Modifier n modifie aussi r
  std::cout << n << " " << m << " " << r << "\n";
}
