#include <iostream>
#include <cmath>

double racine(double a)
{
  /*
	La methode de Newton pour la fonction x^2-a s'ecrit :
	x_{n+1} = 1/2 * (x_n + a/x_n)
   */

  double x=2, y=1; // Valeurs initiales arbitraires
  while (x != y) // Les erreurs d'arrondi assurent que x sera egal a y au bout d'un certain temps
	{
	  x = y;
	  y = (x + a/x)/2;
	}

  return x;
}

int main(void)
{
  for (int i=1; i<=20; i += 1)
	{
	  std::cout << "La racine de " << i << " est " << racine(i);
	  std::cout << (racine(i)==sqrt(i) ? ",\tegal au" : ",\tdifferent du") <<" resultat de sqrt." << std::endl;
	}

  // La syntaxe a ? b : c test si a est vrai ou faux. Si a est vrai, on renvoie b, sinon on renvoie c.

  return 0;
}

