#include "fonction.hpp"
#include <fstream>


class F : public fonction
{
public:
  double operator() (double x)
  {
	return log( 1 + x*x + cos(x)*cos(x) + exp(x));
  }
};


const double L = 3;
const int nb_points = 200;
const double dx = L/nb_points;

int main(void)
{
  F F;
  std::ofstream sortie("graphe.dat");

  for (int i=-nb_points; i<=nb_points; i++)
	sortie << i*dx << " " << F(i*dx) << " " << F.delta(i*dx) << "\n";
  return 0;
}

